---
title: BlobBuilder
slug: Web/API/BlobBuilder
tags:
  - API
  - DOM
  - DOM Reference
  - File API
  - Obsolete
  - Reference
---
<p>{{APIRef("File API")}}{{ obsolete_header}}</p>

<p>The <strong><code>BlobBuilder</code></strong> interface provides an easy way to construct {{domxref("Blob")}} objects. Just create a <code>BlobBuilder</code> and append chunks of data to it by calling the {{manch("append")}} method. When you're done building your blob, call {{manch("getBlob")}} to retrieve a {{domxref("Blob")}} containing the data you sent into the blob builder.</p>

<div class="note"><strong>Note:</strong> The <code>BlobBuilder</code> interface has been deprecated in favor of the newly introduced {{domxref('Blob')}} constructor.</div>

<h2 id="Method_overview">Method overview</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <td><code>void <a href="/en-US/docs/Web/API/BlobBuilder#append()">append</a>(in ArrayBuffer data);</code></td>
  </tr>
  <tr>
   <td><code>void <a href="/en-US/docs/Web/API/BlobBuilder#append()">append</a>(in Blob data);</code></td>
  </tr>
  <tr>
   <td><code>void <a href="/en-US/docs/Web/API/BlobBuilder#append()">append</a>(in String data, [optional] in String endings);</code></td>
  </tr>
  <tr>
   <td><code>Blob <a href="/en-US/docs/Web/API/BlobBuilder#getBlob()">getBlob</a>([optional] in DOMString contentType);</code></td>
  </tr>
  <tr>
   <td><code>File <a href="/en-US/docs/Web/API/BlobBuilder#getFile()">getFile</a>(in DOMString name, [optional] in DOMString contentType);</code></td>
  </tr>
 </tbody>
</table>

<h2 id="Methods">Methods</h2>

<h3 id="append()">append()</h3>

<p>Appends the contents of the specified JavaScript object to the {{domxref("Blob")}} being built. If the value you specify isn't a {{domxref("Blob")}}, <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/ArrayBuffer"><code>ArrayBuffer</code></a>, or <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/String"><code>String</code></a>, the value is coerced to a string before being appended to the blob.</p>

<pre class="syntaxbox">void append(
  in ArrayBuffer data
);

void append(
  in Blob data
);

void append(
  in String data,
  [optional] in String endings
);
</pre>

<h6 id="Parameters">Parameters</h6>

<dl>
 <dt><code>data</code></dt>
 <dd>The data to append to the {{domxref("Blob")}} being constructed.</dd>
 <dt><code>endings</code></dt>
 <dd>Specifies how strings containing <code>\n</code> are to be written out. This can be <code>"transparent"</code> (endings unchanged) or <code>"native"</code> (endings changed to match host OS filesystem convention). The default value is <code>"transparent"</code>.</dd>
</dl>

<h3 id="getBlob()">getBlob()</h3>

<p>Returns the {{domxref("Blob")}} object that has been constructed using the data passed through calls to {{manch("append")}}.</p>

<pre class="syntaxbox">Blob getBlob(
  in DOMString contentType {{optional_inline}}
);
</pre>

<h6 id="Parameters_2">Parameters</h6>

<dl>
 <dt><code>contentType</code> {{optional_inline}}</dt>
 <dd>The MIME type of the data to be returned in the {{domxref("Blob")}}. This will be the value of the <code>Blob</code> object's type property.</dd>
</dl>

<h6 id="Return_value">Return value</h6>

<p>A {{domxref("Blob")}} object containing all of the data passed to any calls to {{manch("append")}} made since the <code>BlobBuilder</code> was created. This also resets the <code>BlobBuilder</code> so that the next call to {{manch("append")}} is starting a new, empty blob.</p>

<h3 id="getFile()_non-standard_inline">getFile() {{non-standard_inline}}</h3>

<p>Returns a {{domxref("File")}} object.</p>

<pre class="syntaxbox">File getFile(
  in DOMString name,
  [optional] in DOMString contentType
);
</pre>

<h6 id="Parameters_3">Parameters</h6>

<dl>
 <dt><code>name</code></dt>
 <dd>The file name.</dd>
 <dt><code>contentType</code> {{optional_inline}}</dt>
 <dd>The MIME type of the data to be returned in the {{domxref("File")}}. This will be the value of the <code>File</code> object's type property.</dd>
</dl>

<h6 id="Return_value_2">Return value</h6>

<p>A {{domxref("File")}} object.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.BlobBuilder")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{spec("http://dev.w3.org/2009/dap/file-system/file-writer.html#idl-def-BlobBuilder", "File API Specification: BlobBuilder", "ED")}}</li>
 <li>{{domxref("Blob")}}</li>
 <li>{{domxref("File")}}</li>
</ul>
